// Karma configuration
// Generated on Tue Dec 22 2015 18:29:31 GMT+0100 (CET)

module.exports = (config) => {
  config.set({

    // base path that will be used to resolve all patterns (eg. files, exclude)
    basePath: '',

    // frameworks to use
    // available frameworks: https://npmjs.org/browse/keyword/karma-adapter
    frameworks: ['jasmine'],

    // list of files / patterns to load in the browser
    files: [
      'node_modules/webrtc-adapter/out/adapter_no_edge_no_global.js',
      'dist/netflux.es2015.umd.js',
      'test/**/*.test.js'
    ],

    // list of files to exclude
    exclude: [
      'test/node/*'
    ],

    // preprocess matching files before serving them to the browser
    // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
    preprocessors: {
      'test/**/*.test.js': ['rollup']
    },

    rollupPreprocessor: {
      rollup: {
        plugins: [
          require('rollup-plugin-string')({
            include: 'test/**/*.txt'
          }),
          require('rollup-plugin-includepaths')({
            paths: ['', 'src/', 'test/'],
            extensions: ['.js', '.txt']
          })
        ]
      },
      bundle: {
        format: 'iife'
      }
    },

    // test results reporter to use
    // possible values: 'dots', 'progress'
    // available reporters: https://npmjs.org/browse/keyword/karma-reporter
    reporters: ['spec'],

    specReporter: {
      showSpecTiming: true
    },

    coverageReporter: {
      dir: 'coverage',
      reporters: [
        {type: 'html'},
        {type: 'text-summary'},
        {type: 'lcovonly', subdir: '.'}
      ]
    },

    // web server port
    port: 9876,

    // enable / disable colors in the output (reporters and logs)
    colors: true,

    // level of logging
    // possible values: config.LOG_DISABLE || config.LOG_ERROR || config.LOG_WARN || config.LOG_INFO || config.LOG_DEBUG
    logLevel: config.LOG_INFO,

    // enable / disable watching file and executing tests whenever any file changes
    autoWatch: true,

    failOnEmptyTestSuite: false,

    // start these browsers
    // available browser launchers: https://npmjs.org/browse/keyword/karma-launcher
    browsers: ['Chrome', 'Firefox'],

    // Continuous Integration mode
    // if true, Karma captures browsers, runs the tests and exits
    singleRun: false,

    // Concurrency level
    // how many browser should be started simultanous
    concurrency: Infinity,

    browserNoActivityTimeout: 200000
  })
}
